#ifndef __PRINTF_H__
#define __PRINTF_H__

// debug
#ifdef _DEBUG
#define DPRINTF(arg) PRINTF(arg)
#else
#define DPRINTF(arg)
#endif

// environment dependent
#ifdef _CONSOLE
#define PRINTF(arg) printf arg
#define EOL "\n"
#else
#define PRINTF(arg)
#define EOL "\r\n"
#endif

#endif // __PRINTF_H__
