#ifndef __GAIMEX_H__
#define __GAIMEX_H__

#include "GAunit.h"

class GAimex
{
public:
	CGAparam		*m_param;
	CGAunit			*m_unit;

	// 
	virtual void	init(CGAparam &param, CGAunit &unit);

	// `qAƃȎݕϊ
	// ͊eV~[^̔hNXōs
	virtual void	imex_io2log(int &io_size, CGAstatusIO *io, char *log) = 0;
	virtual void	imex_log2io(int &io_size, CGAstatusIO *io, char *log) = 0;

	// Oo͖{
	virtual void	import_log(CGAparam &param, CGAunit &unit, char *log);
	virtual void	export_log(CGAparam &param, CGAunit &unit, char *log);

	// Tu֐
	void			_strcat(char *log, char *format, ...);
	bool			_sgets(char *&pos, char *buf);
	void			_fix_stat();

	// Tu֐()
	inline ETYPE	conv_elem2type(ETYPE elem)     { return elem & ELEM_MASK_TYPE; };
	inline int		conv_elem2idx(ETYPE elem)      { return elem & ELEM_MASK_INDEX; };
	inline int		conv_str2idx(char *str)        { return m_param->str2idx(str); };
	inline char *	conv_idx2str_xien(int index)   { return m_param->xien_name(index); };
	inline char *	conv_idx2str_stat(int index)   { return m_param->stat_name(index); };
	inline char *	conv_elem2str(ETYPE elem)      { return 
		conv_elem2type(elem) == ELEM_TYPE_XIEN ? conv_idx2str_xien(conv_elem2idx(elem)) :
		conv_elem2type(elem) == ELEM_TYPE_STAT ? conv_idx2str_stat(conv_elem2idx(elem)) : conv_idx2str_xien(0);
	};
	inline ETYPE	conv_idx2elem_xien(int index)  { return ELEM_TYPE_XIEN | ((ETYPE)index << ELEM_STARTBIT_VALUE); };
	inline ETYPE	conv_idx2elem_stat(int index)  { return ELEM_TYPE_STAT | ((ETYPE)index << ELEM_STARTBIT_VALUE); };
	inline ETYPE	conv_str2elem_xien(char *str)  { return conv_idx2elem_xien(conv_str2idx(str)); };
	inline ETYPE	conv_str2elem_stat(char *str)  { return conv_idx2elem_stat(conv_str2idx(str)); };
	inline char *	conv_idx2str_chara(int chara, bool use_oldname = false)
			{ return m_param->idx2str_chara(chara, use_oldname); };
	inline char *	conv_idx2str_style(int style)
			{ return m_param->style_name(style); };
	inline char *	conv_idx2str_cstyle(int style, bool use_oldname = false)
			{ return m_param->idx2str_style(style, use_oldname); };
};

class GAimex_gasim : GAimex
{
public:
	void	imex_io2log(int &io_size, CGAstatusIO *io, char *log);
	void	imex_log2io(int &io_size, CGAstatusIO *io, char *log);
};

class GAimex_oresim : GAimex
{
public:
	void	imex_io2log(int &io_size, CGAstatusIO *io, char *log);
	void	imex_log2io(int &io_size, CGAstatusIO *io, char *log);
};

class GAimex_saibunpai : GAimex
{
public:
	void	imex_io2log(int &io_size, CGAstatusIO *io, char *log);
	void	imex_log2io(int &io_size, CGAstatusIO *io, char *log);
};

class GAimex_talessimu : GAimex
{
public:
	void	imex_io2log(int &io_size, CGAstatusIO *io, char *log);
	void	imex_log2io(int &io_size, CGAstatusIO *io, char *log);
};

#endif // __GAIMEX_H__
